| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | export DOCKER_HOST="unix:///var/run/docker.sock" |
| 3 | |
| 4 | set -e |
| 5 | set -x |
| 6 | |
| 7 | W() { |
| cgeoffroy | 349dc0b | 2017-03-15 16:24:58 +0100 | [diff] [blame] | 8 | # Wait until a line appears in the screen session. |
| 9 | # It starts from the beginning of the log and exits after the first match. |
| 10 | local T=${2:-20s} |
| 11 | #timeout -k 3s ${T} stdbuf -o0 grep -q -m 1 "^${1}" <(tail -F -n+0 screenlog.0) |
| 12 | # (HACK) As Jenkins blocks subshell, we must use an intermediate script |
| 13 | local SUBF=$(mktemp) |
| 14 | chmod +x ${SUBF} |
| 15 | cat > ${SUBF} <<- EOF |
| 16 | #!/bin/bash -e |
| 17 | while true; do |
| 18 | if strings screenlog.0 | grep -m 1 "\${1}"; then |
| 19 | exit 0 |
| 20 | fi |
| 21 | sleep 0.5s |
| 22 | done |
| 23 | EOF |
| 24 | timeout -k 3s ${T} ${SUBF} "${1}" |
| 25 | local RES=$? |
| 26 | rm -f ${SUBF} |
| 27 | return ${RES} |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 28 | } |
| 29 | |
| 30 | Cmd() { |
| 31 | # Send a command to the screen session, aka into the containernet prompt |
| 32 | screen -S sonemu -X stuff "${1}^M" |
| 33 | } |
| 34 | |
| 35 | |
| 36 | if ! screen --version | grep 'Screen version'; then |
| 37 | # Install screen and do an initial cleanup |
| 38 | sudo apt-get update -qq -y |
| 39 | sudo apt-get install -y screen |
| 40 | screen --version | grep 'Screen version' |
| 41 | fi |
| cgeoffroy | ae307a9 | 2017-03-17 10:48:26 +0100 | [diff] [blame] | 42 | if ! timeout --version; then |
| 43 | # Install coreutils for the timeout command |
| 44 | sudo apt-get update -qq -y |
| 45 | sudo apt-get install -y coreutils |
| 46 | timeout --version |
| 47 | fi |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 48 | # Initial cleanup |
| cgeoffroy | 7511f6d | 2017-03-17 11:22:47 +0100 | [diff] [blame] | 49 | pkill -f 'SCREEN -L -S sonemu' || true |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 50 | screen -wipe || true |
| 51 | rm -f screenlog.0 |
| 52 | |
| 53 | |
| 54 | # Start containernet with a topology |
| cgeoffroy | 4b9ba68 | 2017-03-17 12:51:18 +0100 | [diff] [blame] | 55 | screen -L -S sonemu -d -m sudo python src/emuvim/examples/simple_topology.py |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 56 | # Setup screen for immediate flusing |
| 57 | screen -S sonemu -X logfile flush 0 |
| 58 | # Wait for the cli to start |
| cgeoffroy | 736c4aa | 2017-03-17 11:48:15 +0100 | [diff] [blame] | 59 | W '^*** Starting CLI:' 60s |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 60 | # Print nodes |
| 61 | Cmd 'nodes' |
| 62 | # Start vnf1 |
| 63 | son-emu-cli compute start -d datacenter1 -n vnf1 && sleep 1s |
| 64 | # Start vnf2 |
| 65 | son-emu-cli compute start -d datacenter1 -n vnf2 && sleep 1s |
| 66 | # List compute nodes |
| 67 | son-emu-cli compute list && sleep 1s |
| 68 | # Gather some infos |
| 69 | Cmd 'sh echo "... starting various checks"' |
| cgeoffroy | 6f86be7 | 2017-03-17 13:26:50 +0100 | [diff] [blame] | 70 | sync # avoid text overlapping |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 71 | Cmd 'vnf1 ifconfig && echo "... checked vnf1"' |
| cgeoffroy | 349dc0b | 2017-03-15 16:24:58 +0100 | [diff] [blame] | 72 | W "^... checked vnf1" |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 73 | Cmd 'vnf2 ifconfig && echo "... checked vnf2"' |
| cgeoffroy | 349dc0b | 2017-03-15 16:24:58 +0100 | [diff] [blame] | 74 | W "^... checked vnf2" |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 75 | # Try to ping vnfs |
| cgeoffroy | 2530a1a | 2017-03-23 15:36:56 +0100 | [diff] [blame] | 76 | Cmd 'vnf1 ping -c 2 vnf2 && echo "... checked ping"' |
| cgeoffroy | 349dc0b | 2017-03-15 16:24:58 +0100 | [diff] [blame] | 77 | W "^... checked ping" 20s |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 78 | Cmd 'quit' |
| 79 | # Wait for sonemu to end |
| cgeoffroy | 349dc0b | 2017-03-15 16:24:58 +0100 | [diff] [blame] | 80 | W '^*** Done' |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 81 | |
| cgeoffroy | 349dc0b | 2017-03-15 16:24:58 +0100 | [diff] [blame] | 82 | echo -e '\n\n******************* Result ******************\n\n' |
| cgeoffroy | 549e20f | 2017-03-03 16:10:40 +0100 | [diff] [blame] | 83 | strings screenlog.0 |
| 84 | echo -e '\n\n*********************************************\n\n' |
| 85 | |
| 86 | |
| 87 | # Check the ping result |
| 88 | if grep ', 2 received' screenlog.0; then |
| 89 | echo 'No problems detected' |
| 90 | exit 0 |
| 91 | else |
| 92 | echo 'Ping is broken !' |
| 93 | exit 1 |
| 94 | fi |